{ sources, ... }@args:

let
  pkgs = import sources.nixpkgs args;
  oldstable = import sources.nixpkgs-oldstable args;
  unstable = import sources.nixpkgs-unstable args;

  callPackage = pkgs.lib.callPackageWith (pkgs // newpkgs);

  newpkgs = {

    mattermost = callPackage ./mattermost.nix {
      inherit sources;
      buildGoModule = unstable.buildGo122Module;
    };

    tracktrain = import sources.tracktrain {
      nixpkgs = pkgs;
      compiler = "default";
    };

    uffd = oldstable.callPackage ./uffd { };

    inherit (oldstable) uwsgi flask;
  };

in pkgs.extend(_: _: newpkgs)
